var UglifyJS=require('uglifyjs');
var util=require('util');
var Record=require('./record');
var jqAlias=[];
Object.getOwnPropertyNames(UglifyJS).forEach(function(name){global[name]=UglifyJS[name]});
function isInvoke$(node){
  var nameNode;
  if(node.__collected)return false;
  if( node instanceof AST_Call)
    if((nameNode=node.expression) instanceof AST_SymbolRef)
      return jqAlias.indexOf(nameNode.name)>-1;
    else
      return isInvoke$(node.expression);
  else if(node instanceof AST_PropAccess)
      return isInvoke$(node.expression);
}
function collectMethodInfo(node,record){
  var temp;
  record=record||Record();
  if(node instanceof AST_Call){
    if(AST_SymbolRef && jqAlias.indexOf(node.expression.name)>-1)
      record.invoke(node.expression.name,node.args,node.start);
    else if((temp=node.expression) instanceof AST_PropAccess) {
      record.chain({args:node.args,end:node.end});
      collectMethodInfo(temp,record);
    }
  }
  else if( node instanceof AST_PropAccess){
    if(node.expression instanceof AST_Call &&! record.hasChain()){
      collectMethodInfo(node.expression,record);
      record.chain({args:node.property,end:node.end,name:'',start:node.start});
    }
    else{
      record.setLastChain({name:node.property,start:node.start});
      collectMethodInfo(node.expression,record)
    }
  }
  record.end=node.end;
  node.__collected=1;
  return record;
}
function detect(code,options){
  setOptions(options);
  var tw=new TreeWalker(walkUp),records=[];
  parse(code+'').walk(tw);
  return records;
  function walkUp(node){
    if(isInvoke$(node))
    {
      records.push(collectMethodInfo(node));
      return !(node.args&&(node.args[0] instanceof AST_Function)) ;
    }
  }
}
function setOptions(options){
  options=options||{};
  jqAlias=options.jQNames||['$','jQuery'];
}
module.exports=detect;

