/**
 * Created by Administrator on 2015/6/2.
 */
var chalk=require('chalk');
function Record(options){
  if(!(this instanceof Record))
    return new Record(options);
  this.chains=[];
}
Record.prototype={
  invoke:function(invokeName,args,startToken){
    this.invokeName=invokeName;
    this.args=args.slice();
    this.start=startToken;
  },
  hasChain:function(){
    var chain=this.chains[0];
    return chain&& typeof chain.args.map==="function" && !chain.name
  },
  chain:function(options){
    this.chains.unshift(options);
  },
  setLastChain:function(options){
    if(!this.chains[0])debugger;
    clone(options,this.chains[0]);
  },
  report:function(){
    var ret=[$s('%i\t%i(%i)',printLoc(this.start),printNode(this.invokeName,chalk.yellow),printArgs(this.args))];
    return ret.concat(this.chains.map(printChain)).join('')+'\n';
  }
};
function printChain(chain){
  var args=chain.args;
  if(args.map)
    return $s('\n%i\t.%i(%i)\n',printLoc(chain.end),chalk.yellow(chain.name),printArgs(chain.args));
  return $s('[%i]',printNode(args,chalk.green));
}
function printArgs(args){
  return args.map(function(arg){
    return printNode(arg,chalk.green)
  }).join(',')
}
function printLoc(node){
  return chalk.cyan(node.line)+':'+chalk.cyan(node.col)
}
function printNode(node,process){
  var ret;
  if(typeof node ==="string") ret=node;
  else if(node.TYPE=='Function') ret=chalk.gray('func: ')+(node.name? node.name.name:'');
  else ret=node.print_to_string();
  return process? (process(ret)||ret):ret;
}

function $s(string){
  var args=[].slice.apply(arguments,[1]);
  return string.replace(/%i/g,function(){ return args.shift();})
}
function clone(from,target){
  objForEach(from,function(v,k){target[k]=v });
  return target;
}
function objForEach(obj,callback,thisObj){
  if(obj){
    thisObj=thisObj||obj;
    Object.getOwnPropertyNames(obj).forEach(function(name){
      callback.call(thisObj,obj[name],name);
    })
  }
}
module.exports=Record;